;*********************************************************************
;*              ROM dump program for FX-870P/VX-4/VX-3               *
;*               (C)2009 Miyura (miyura321@ybb.ne.jp)                *
;*********************************************************************

FX870P:	EQU	1			;FX-870P/VX-4
VX3:	EQU	2			;VX-3
MODEL:	EQU	FX870P

PBF:	EQU	1			;1:Mɉ]\

#if MODEL=FX870P
;
;	system call
;
PRLCD:	EQU	&H940E			;$16LCD1\
B2DEC:	EQU	&H50B4			;$3,$4̓e10iɕϊIXȍ~Ɋi[
BIOS:	EQU	&H5321			;BIOS(BANK0)R[BANK1ɖ߂
RSOPN:	EQU	&H84EC			;RS232C OPEN
RSCLO:	EQU	&H8563			;RS232C CLOSE
PRTRS:	EQU	&H85FB			;RS232C M
;
;	work area
;
EDCSR:	EQU	&H1101			;J[\ʒu
RSFG:	EQU	&H173E			;RS232CpftHgl
;
;	start address
;
BASE:	EQU	&H1CD0
#else
;
;	system call
;
PRLCD:	EQU	&H2102			;$16LCD1\
B2DEC:	EQU	&H5A32			;$3,$4̓e10iɕϊIXȍ~Ɋi[
BIOS:	EQU	&H5CA7			;BIOS(BANK0)R[BANK1ɖ߂
RSOPN:	EQU	&H2535			;RS232C OPEN
RSCLO:	EQU	&H2582			;RS232C CLOSE
PRTRS:	EQU	&H2621			;RS232C M
RSEN:	EQU	&H4E19			;RS232C MH/W(MRSOPNOɎs/VX-3̂)
;
;	work area
;
EDCSR:	EQU	&H6101			;J[\ʒu
RSFG:	EQU	&H6737			;RS232CftHgl
;
;	start address
;
BASE:	EQU	&H6CD0
#endif


	ORG	BASE
	START	START
;
;	display message
;
START:	LDW	$0,EDCSR		;J[\ʒu4sڐ擪ɐݒ
	ST	&H60,($0)		;

	PRE	IZ,MSG01
	LD	$18,11
MSG:	LDI	$16,(IZ+$31)		;"saving pbf."\
	LDW	$28,PRLCD
	CAL	RCS
	SB	$18,$30
	JR	NZ,MSG
;
;	open RS232C
;
#if MODEL=VX3
	LDW	$28,RSEN		;RS232CMH/W
	CAL	RCS			;
#endif
	PRE	IX,RSFG			;F.COMftHglǂݍ
	LDM	$11,(IX+$31),3		;
	LD	$0,&H02			;Mw
	LDW	$28,RSOPN		;RS232C OPEN
	CAL	RCS
;
;	set ROM dump area
;
	LDW	$19,&H0C00		;$19,20 = JnAhX
	LDW	$21,&HFFFF		;$21,22 = IAhX
	LDW	$26,$19			;$26,27 = sAhX
;
;	send file name
;
	LD	$13,7			;ݒ
	CAL	XSNDM			;LN^̑M
	CAL	XCOMMA			;R}M
;
;	send file address
;
	LDW	$3,$19			;JnAhX10iϊđM
	CAL	XDEC			;
	CAL	XCOMMA			;R}M
	LDW	$3,$21			;IAhX10iϊđM
	CAL	XDEC			;
	CAL	XSUM			;sAhX10iϊđM
;
;	send binary data
;
	LD	$18,$31

#if PBF
	LD	$21,&H83		;o̓[h
	LDW	$22,&H03A2		;Ww
	LDW	$24,&HE060		;R[hݒ
#endif

XBIN:	LD	$10,120			;1sf[^Zbg
	XRW	$26,$26			;`FbNT

XBIN1:	PST	UA,&H45			;bank 0
	LD	$17,($19)		;1oCgǂݍ
	PST	UA,&H55			;bank 1

	ADW	$26,$17			;`FbNTZ

#if PBF
	ANC	$19,&H3F		;16oCgMɕ\
	JR	LNZ,XBIN2		;

	PPO	&HC7			;LCDR}hWX^w肷 
	STLM	$21,3			;(R}hݒ) 
	PPO	&HC6			;LCDf[^ݎw
	STL	$24			;1\

	XR	$24,$25			;60H->80H->70H->90H->60H
	XR	$25,&H10		;
#endif

XBIN2:	LD	$16,$17			;
	DID	$16			;ʌASCIIϊđM
	CAL	XASC			;

	LD	$16,$17			;ʌASCIIϊđM
	CAL	XASC			;

	ADW	$19,$30			;|C^ + 1
	JR	Z,XCLOSE		;I`FbN

	SB	$10,$30			;1sI`FbN
	JR	NZ,XBIN1		;

	CAL	XSUM			;`FbNTf[^M
	JR	XBIN
;
;	termination process
;
XCLOSE:	CAL	XSUM			;`FbNTf[^M
	PST	UA,&H54
	JP	RSCLO			;RS232CN[Y
;
;	send decimal data
;
XDEC:	PRE	IX,FNAME		;FNAMEobt@Ɏgp
	LD	$13,$31			;JE^Zbg
	LDW	$28,B2DEC		;$3,$4̓e10iɕϊ
	CAL	RCS			;
	SBC	$13,$31			;
	JR	NZ,XSNDM		;Ml0̏ꍇ
	LD	$16,"0",XSEND		;"0"M
;
;	send multi byte data
;
XSNDM:	PRE	IX,FNAME		;FNAMEobt@Ɏgp
XSND01:	LDI	$16,(IX+$31)		;1o
	CAL	XSEND			;$16̃f[^RS232CőM
	SB	$13,$30			;
	JR	NZ,XSND01		;
	RTN
;
;	send check sum data
;
XSUM:	CAL	XCOMMA			;R}o

	LDW	$3,$26			;`FbNTf[^(܂͎sAhX)
	CAL	XDEC			;10iϊđM

	LD	$16,&H0D		;0Dho
	CAL	XSEND
	LD	$16,&H0A,XSEND		;0Aho
;
;	send comma
;
XCOMMA:	LD	$16,",",XSEND
;
;	send ascii data
;
XASC:	AN	$16,&H0F		;digitNA
	OR	$16,&H30		;+'0'
	SBC	$16,&H3A		;$16'1'`'9'ȂXSEND
	JR	C,XSEND
	AD	$16,&H07		;$16='A'`'F'
;
;	send the $16 via RS232C
;
XSEND:	GRE	IX,$6			;IXۑ
	LDW	$28,PRTRS		;$16̃f[^RS232CőM
	PST	UA,&HD4			;(IZ=BANK3)
	CAL	BIOS			;
	PRE	IX,$6			;IXA
	RTN

RCS:	PST	UA,&H54
	JP	BIOS

FNAME:	DB	"ROM.BIN"		;output file name
MSG01:	DB	"saving pbf."		;message data
